<?php

function plugin_init_manage() {
	global $plugin_hooks;
	$plugin_hooks['top_header_tabs']['manage'] = 'manage_show_tab';	
	$plugin_hooks['top_graph_header_tabs']['manage'] = 'manage_show_tab';
	$plugin_hooks['config_arrays']['manage'] = 'manage_config_arrays';
	$plugin_hooks['poller_bottom']['manage'] = 'manage_poller_bottom';
	$plugin_hooks['draw_navigation_text']['manage'] = 'manage_draw_navigation_text';
	$plugin_hooks['config_form']['manage'] = 'manage_config_form';
	$plugin_hooks['api_device_save']['manage'] = 'manage_api_device_save';
	$plugin_hooks['config_settings']['manage'] = 'manage_config_settings';	
}

function manage_version () {
	return array( 'name' 		=> 'manage',
			'version' 	=> '0.1',
			'longname'	=> 'manage',
			'author'	=> 'Gilles Boulon',
			'homepage'	=> 'http://forums.cacti.net/viewtopic.php?t=13827',
			'email'		=> '',
			'url'		=> ''
			);
}

function manage_config_form () {
	global $fields_host_edit;
	$fields_host_edit2 = $fields_host_edit;
	$fields_host_edit3 = array();
	foreach ($fields_host_edit2 as $f => $a) {
		$fields_host_edit3[$f] = $a;
		if ($f == 'disabled') {
			$fields_host_edit3["manage"] = array(
				"method" => "checkbox",
				"friendly_name" => "Manage Host",
				"description" => "Check this box to manage this host.",
				"value" => "|arg1:manage|",
				"default" => "off",
				"form_id" => false
			);
		} 
	}
	$fields_host_edit = $fields_host_edit3;
}

function manage_setup_table () {
	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");
	$sql = "show columns from host from `" . $database_default . "`";
	$result = mysql_query($sql) or die (mysql_error());
	$found = false;
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		if ($row['Field'] == 'manage')
			$found = true;
	}
	if (!$found) {
		$sql = "alter table host add manage char(3) default '' not null after disabled";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_host ( id mediumint(8) unsigned NOT NULL default '0', uptime bigint(20) default NULL, type mediumint(8) unsigned NOT NULL default '0', services text, statut text)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_method ( id mediumint(8) unsigned NOT NULL default '0', method text)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_alerts (idh mediumint(8) unsigned NOT NULL default '0', datetime datetime NOT NULL default '0000-00-00 00:00:00', ids mediumint(8) unsigned default '0', message text, note text, ida mediumint(9) unsigned NOT NULL auto_increment, PRIMARY KEY  (ida))";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "CREATE TABLE manage_host_services ( id mediumint(8) unsigned NOT NULL default '0', services mediumint(8) unsigned default '', statut text)";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_events', '5')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_poller', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_method', '0')";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO settings VALUES ('manage_date', '0')";
		$result = mysql_query($sql) or die (mysql_error());		
	}
}


function manage_poller_bottom () {
// penser  retoucher pour pouvoir choisir le poller
	global $config;

	manage_setup_table();
	$p = dirname(__FILE__);

	if ($config["cacti_server_os"] == "unix") {
		$command_string = read_config_option("path_php_binary");
		$extra_args = "-q " . $p . "/check-manage.php";
	} else {
		$command_string = read_config_option("path_php_binary");
		$extra_args = "-q " . strtolower($p . "/check-manage.php");
	}
	$manage_poller = db_fetch_cell("select value from settings where name ='manage_poller'",'');
	if ($manage_poller == '0') {
	  exec_background($command_string, $extra_args);
	}
}


function manage_api_device_save ($save) {
	if (isset($_POST['manage']))
		$save["manage"] = form_input_validate($_POST['manage'], "manage", "", true, 3);
	else
		$save['manage'] = form_input_validate('', "manage", "", true, 3);
	return $save;
}


function manage_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames, $menu;
	$user_auth_realms[56]='Use Manage';
	$user_auth_realm_filenames['manage.php'] = 56;
//	$user_auth_realm_filenames['listmanage.php'] = 56;
	$user_auth_realm_filenames['listmanage2.php'] = 56;
	$user_auth_realm_filenames['viewalerts.php'] = 56;
//	$user_auth_realm_filenames['listmanage3.php'] = 56;
	
	$menu2 = array ();
	foreach ($menu as $temp => $temp2 ) {
		$menu2[$temp] = $temp2;
		if ($temp == 'Management') {
//			$menu2["Manage"]['plugins/manage/listmanage.php'] = "Configuration";
			$menu2["Manage"]['plugins/manage/listmanage2.php'] = "Configuration";
			$menu2["Manage"]['plugins/manage/viewalerts.php'] = "View alerts";
		}
	}
	$menu = $menu2;
}




function manage_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;
	$realm_id2 = 0;

	if (isset($user_auth_realm_filenames{basename('manage.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('manage.php')};
	}
	if ((db_fetch_assoc("select user_auth_realm.realm_id
		from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
		and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

		print '<a href="' . $config['url_path'] . 'plugins/manage/manage.php"><img src="' . $config['url_path'] . 'plugins/manage/images/tab_manage.gif" alt="Manage" align="absmiddle" border="0"></a>';

	}
	manage_setup_table();
}


function manage_draw_navigation_text ($nav) {
  $nav["manage.php:"] = array("title" => "Manage", "mapping" => "index.php:", "url" => "manage.php", "level" => "1");
//  $nav["listmanage.php:"] = array("title" => "Manage", "mapping" => "index.php:", "url" => "listmanage.php", "level" => "1");
  $nav["listmanage2.php:"] = array("title" => "Configuration", "mapping" => "index.php:", "url" => "listmanage2.php", "level" => "1");
  $nav["listmanage2.php:edit"] = array("title" => "Configuration", "mapping" => "index.php:", "url" => "listmanage2.php", "level" => "1");
//  $nav["listmanage.php:actions"] = array("title" => "Manage", "mapping" => "index.php:", "url" => "listmanage.php", "level" => "1");
  $nav["listmanage2.php:actions"] = array("title" => "Configuration", "mapping" => "index.php:", "url" => "listmanage2.php", "level" => "1");
//  $nav["listmanage3.php:"] = array("title" => "Manage", "mapping" => "index.php:", "url" => "listmanage3.php", "level" => "1");
//  $nav["listmanage3.php:actions"] = array("title" => "Manage", "mapping" => "index.php:", "url" => "listmanage2.php", "level" => "1");
  $nav["viewalerts.php:"] = array("title" => "View alerts", "mapping" => "index.php:", "url" => "viewalerts.php", "level" => "1");
  $nav["viewalerts.php:actions"] = array("title" => "View alerts", "mapping" => "index.php:", "url" => "viewalerts.php", "level" => "1");
  return $nav;
}


function manage_config_settings () {
	global $tabs, $settings;
	$tabs["misc"] = "Misc";
	$temp = array(
		"general_header" => array(
			"friendly_name" => "Plugin Manage",
			"method" => "spacer",
		),
		"manage_method" => array(
			"friendly_name" => "Method to test connexion with host",
			"description" => "SNMP is recommended.<br>NOTE: ICMP Ping requires that the Cacti Service ID have root privileges in Unix.",
			"method" => "drop_array",
			"array" => array(0 => 'SNMP (uptime check)', 1 => 'SNMP (sysdescr check)', 2 => 'UDP Ping (with risk)', 3 => 'ICMP Ping (with risk)' ),
		),
		"manage_poller" => array(
			"friendly_name" => "Type of poller",
			"description" => "You can use the default task Cacti poller. If you need a faster poller, scheduled another task with check-manage.php.",
			"method" => "drop_array",
			"array" => array(0 => 'Cacti poller', 1 => 'Manage poller'),
		),
		"manage_events" => array(
			"friendly_name" => "Enable mail alerts",
			"description" => "",
			"method" => "drop_array",
			"array" => array(0 => 'UP events', 1 => 'DOWN events', 2 => 'Reboot events', 3 => 'UP and DOWN events', 4 => 'DOWN and reboot events', 5 => 'None'),
		)
	);
	if (isset($settings["misc"]))
		$settings["misc"] = array_merge($settings["misc"], $temp);
	else
		$settings["misc"]=$temp;	
	
}


	
?>